/* Last updated on 13 Jun 2005, at 18:54.  */
; Process 00global.txt file from hobbes, remove some unused files and calla REXX
; command to create a HTML file  that can be used within Netscape or mozilla
; to download selected file.

const
compile if not defined(WGET_DOWNDIR)
   WGET_DOWNDIR  = 'G:\$down\'
compile endif


defc hobbes=
 universal last_string_found
 universal default_search_options
 universal search_len

 -- process command line parms
 parse value arg(1) with  fr yf
 if fr = '?' | fr = '' then
    call Mhelp()
    return
 elseif verify(fr, '0123456789') then  -- contained a non-numeric character
    fr = 'from'
 else
    yf = fr
    fr = ''
    if verify(yf, '0123456789') then   -- contained a non-numeric character
       call winmessagebox('HOBBES','Year date entered is not NUMERIC !',16432)
       return
    endif
 endif
 if length(yf) <> 4 then
    call winmessagebox('HOBBES','Year date entered is not valid !',16432)
    return
 else
-- showmessage('Year 'yf)
 endif

 getfileid fileid
 last_string_found=0
 search_starlst='./'


if insert_state() then
   insert_toggle
endif

 fn = entrybox("Enter filename:",'/OK/','00globalD.txt')
 if fn = '00global.txt' then
    ft = ''
 else
    ft = 'd'
 endif
 if fn = '' then
    fn = WGET_DOWNDIR || '00globald.txt'
    ft = 'd'
 else
    fn = WGET_DOWNDIR || fn
 endif
--sayerror 'Date/Fname='yf'/'fn

 .autosave = 0
 'xcom edit /d ' fn
 if rc then
   if rc = -282 then  -- sayerror("New file")
      'quit'
      sayerror fn 'does not exist.'
   else
      sayerror 'Error' rc 'loading' fn '-' sayerrortext(rc)
   endif
   return
 endif
 getfileid fn
 .autosave = 0

------ Prepare file ---------------------
 bottom
 insert
 beginline
 keyin './'
 insert
 beginline
 keyin './END'
 top
 up
 insert
 beginline
 keyin './ '
 insert
 beginline
 keyin './ '

---------  Deleting unuseful lines ----------

exp1 = '00index'
exp2 = '00global'
exp3 = '00files'

top
call expunge(exp1)
top
call expunge(exp2)
top
call expunge(exp3)
top

line = 1
 for line = 1 to .last
         cols=0
         getline cline, line
         cline = substr(cline,1,20)
         cols = pos('/ ', cline)
         if cols | substr(cline, 21, 3)='DIR' then
;call logerror('LINE='line' POS=' cols ' CL='cline)
            .line = line
            deleteline
;sayerror 'Deleted line: 'cline
            line = line-1
          endif
;         refresh       /* commented to improve the process speed */
            if .line >= .last then
             leave
           endif
 endfor
 'save'

if fr = '' then
   exp4 = yf||' not'
   c1 = './'
   c2 = yf || '/./'
   change1_cmd = 'c \' || c1 || '\' || c2 || '\' || 'A*FE'
   change2_cmd = 'c \' || c2 || '\' || c1 || '\' || 'A*FE'
   top
   change1_cmd
   refresh
   top
   call expunge(exp4)
   top
   change2_cmd
   top
endif
-- refresh       /* commented to improve the process speed */

c3 = ''
top
unmark
refresh
line = 1
 while  line <= .last-1 do
        if c3 = './END' then
           leave
        endif
       'XCOM L \'search_starlst'\'
          .line = line
           if .line >= .last-1 then
             leave
           endif
       repeat_find
--     refresh       /* commented to improve the process speed */
       if rc = 0 then
          c1 = substr(textline(.line),1,2)
          c2 = substr(textline(.line + 1),1,2)
          c3 = substr(textline(.line + 1),1,5)
--- The following line was used for debugging
---     and creates a file EPM.LOG in the directory of 00GLOBAL.TXT
--call logerror(' C1='c1  ' LINE='.line' C2='c2 ' LAST='.last)
;        if c2 = './' and c1 = './' | c2=' ' and c1='./' then
         if c2 = './' and c1 = './' then
            deleteline
            up
--call logerror('.LINE='.line)
         endif
         if c2 = ' ' and c1 = './' then
            deleteline
--call logerror('.line='.line)
         endif
         line = .line
       else
       endif
 endwhile

top
refresh
fn = .filename
fpos   = lastpos('\',fn)
fpath  = substr(fn,1,lastpos('\',fn))
prefix = substr(yf,3,2)
fnew  = substr(fn,fpos+3)
yft  = yf || ft
if fr = '' then
   newfn = 'hobbes' || yft || '.txt'
else
   newfn = 'hobbes' || 'FROM' || yft || '.txt'
endif
newfs = fpath || newfn
.filename = newfs
fs = .filename
.autosave = 0
top
up
insert
parse value igetdate() with today';' .
beginline
keyin './ -----  Processed by EPM' ver() ' in data '|| today ||'  -----'
sayerror ' New File ==> 'newfs' - HOBBES process routine ended !'
'save '
'quit'
scmd = 'call HOBB2HTM.CMD 'fs yf''

/*=== Open a SHELL window ===*/
'shell'
.AUTOSAVE = 0
getfileid eco_id
eco_shellid = substr(.filename,16)
'shell_write' eco_shellid scmd
;
/*=== end main program ===*/

defproc Mhelp
  title = 'Help for HOBBES command'
  text = 'The command process the 00GLOBALD.TXT and create a HTM file.'\10\10
  text = 'Syntax:   HOBBES [from] Year'\10\10\10
  text = text||'EXAMPLE:   HOBBES from 2002'\10
  text = text||'create an HTM file with all files from         year 2002 up to date.'\10\10
  text = text||'EXAMPLE:   HOBBES  1990'\10
  text = text||'create an HTM file with ALL files of           year 1990.'\10\10
  call winmessagebox(title, text, 16391)
/*--- end Help ---*/
